////////////////////////////////////////////////////////////////////////////////
//  
//  ConnectedComponentClusterer.m
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 30/08/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "TraversalVisitor.h"

@protocol UndirectedGraph;

@interface ConnectedComponentClusterer : NSObject <TraversalVisitor>
{
  @private
    NSMutableSet* currentComponent;
    
    NSMutableSet* finishedVertices;
}

+ (ConnectedComponentClusterer*) clusterer;

/*!
 * Performs clusterization of a graph connected components.
 *
 * A connected component of an undirected graph is a maximal set of vertices such that there is a path between every pair of vertices.
 *
 * @return A set of vertices sets that form connected components.
 */
- (NSSet*) clusterGraph: (id<UndirectedGraph>) graph;

@end
