////////////////////////////////////////////////////////////////////////////////
//  
//  CyclesDetector.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 20/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "EdgeClassifierDelegate.h"

@class BFTEdgeClassifier;

@protocol Graph;

@interface CyclesDetector : NSObject <EdgeClassifierDelegate>
{
  @private
    id<Graph> graph;
    
    BFTEdgeClassifier* edgeClassifier;
    
    NSMutableSet* cycleEdges;
}

@property(readwrite, retain) id<Graph> graph;

+ (BOOL) isAcyclicGraph: (id<Graph>) G;

+ (NSSet*) cycleEdgesOfGraph: (id<Graph>) G;

///

+ (CyclesDetector*) cyclesDetectorWithGraph: (id<Graph>) G;

- (id) initWithGraph: (id<Graph>) G;

- (BOOL) isAcyclic;

- (NSSet*) cycleEdges;

@end
