////////////////////////////////////////////////////////////////////////////////
//  
//  DirectedSparsePseudograph.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 02/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import "AbstractDirectedGraph.h"

#import <Foundation/Foundation.h>

@interface DirectedSparsePseudograph : AbstractDirectedGraph <NSCopying, NSMutableCopying, NSCoding, NSFastEnumeration>
{
  @protected
    // Vertex -> Pair({IncomingEdges}, {OutgoingEdges}).
    NSMapTable* vertexToPairOfEdgeSets;
    
    // Edge -> Pair(Tail, Head).
    NSMapTable* edgeToPairOfVertices;
}

// Эти проперти не должны применяться в пользовательском коде!
@property(readwrite, copy) NSMapTable* vertexToPairOfEdgeSets;

@property(readwrite, copy) NSMapTable* edgeToPairOfVertices;

@end

#pragma mark - Mutable Version

@interface MutableDirectedSparsePseudograph : DirectedSparsePseudograph <MutableDirectedGraph>

@end
