////////////////////////////////////////////////////////////////////////////////
//  
//  DistanceRecorder.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 12/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "TraversalVisitor.h"

@interface DistanceRecorder : NSObject <TraversalVisitor>
{
  @private
    NSMapTable* vertexToDistance;
    
    vertexType currentlyVisiting;
}

/*!
 * Convenient way to create DistanceRecorder instance.
 */
+ (DistanceRecorder*) distanceRecorder;

/*!
 * Returns distance from start vertex to vertex v.
 *
 * @return NSUIntegerMax if v is not a descendant of the start vertex. Valid distance otherwise.
 */
- (NSUInteger) distanceFromStartVertexTo: (vertexType) v;

@end
