////////////////////////////////////////////////////////////////////////////////
//  
//  EdgeClassifier.m
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 13/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "TraversalVisitor.h"

#import "ElementTypes.h"

@protocol EdgeClassifierDelegate;

@interface AbstractEdgeClassifier : NSObject <TraversalVisitor>
{
  @protected
    NSObject<EdgeClassifierDelegate>* delegate;
    
    edgeType currentEdge;
    
    NSHashTable* treeEdges;
}

- (id) initWithDelegate: (NSObject<EdgeClassifierDelegate>*) d;

@end

/*!
 * The concrete subclass of AbstractEdgeClassifier suitable for instantiation.
 */
@interface BFTEdgeClassifier : AbstractEdgeClassifier

@end

@class TimeStamper;

/*!
 * The concrete subclass of AbstractEdgeClassifier suitable for instantiation.
 */
@interface DFTEdgeClassifier : AbstractEdgeClassifier
{
  @private
    TimeStamper* timeStamper;
    
    vertexType currentVertex;
}

@property(readwrite, retain) TimeStamper* timeStamper;

- (id) initWithTimeStamper: (TimeStamper*) timeStamper delegate: (NSObject<EdgeClassifierDelegate>*) d;

@end
