////////////////////////////////////////////////////////////////////////////////
//  
//  PredecessorRecorder.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 14/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "TraversalVisitor.h"

#import "ElementTypes.h"

/*!
 * An object that being a traversal visitor (both BFT & DFT) records parent of each vertex in the connected component.
 */
@interface PredecessorRecorder : NSObject <TraversalVisitor>
{
  @private
    NSMapTable* vertexToParent;
    
    vertexType currentPredecessor;
}

/*!
 * Convenient way to create PredcessorRecorder instance.
 */
+ (PredecessorRecorder*) predecessorRecorder;

/*!
 * Retuns parent vertex of the vertex v.
 *
 * @return Parent of the vertex v, nil if the it wasn't set [yet].
 */
- (vertexType) parentOfVertex: (vertexType) v;

@end
