////////////////////////////////////////////////////////////////////////////////
//  
//  TopologicalSorting.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 19/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "TraversalVisitor.h"

#import "EdgeClassifierDelegate.h"

@class TimeStamper, DFTEdgeClassifier, DepthFirstTraversal;

@protocol DirectedGraph;

@interface TopologicalSorting : NSObject <TraversalVisitor, EdgeClassifierDelegate>
{
  @private
    id<DirectedGraph> directedGraph;
    
    TimeStamper* timeStamper;
    
    DFTEdgeClassifier* edgeClassifier;
    
    DepthFirstTraversal* depthTraversal;
    
    NSMutableArray* topologicalOrder;
}

+ (NSArray*) topologicalSortOfDirectedGraph: (id<DirectedGraph>) diGraph;

+ (TopologicalSorting*) topologicalSortingWithDirectedGraph: (id<DirectedGraph>) diGraph;

- (id) initWithDirectedGraph: (id<DirectedGraph>) diGraph;

- (NSArray*) topologicalSort;

@end
