////////////////////////////////////////////////////////////////////////////////
//  
//  UndirectednessAdapter.h
//  
//  KPMultigraph
//  
//  Created by Konstantin Pavlikhin on 08/09/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import "UndirectedGraph.h"

@protocol DirectedGraph;

/*!
 * Adapter class which represents arbitrary directed graph as immutable undirected one.
 *
 * Implements object adapter pattern.
 *
 * TODO: rename to UndirectorAdapter.
 *
 * Instances of this class should be manually deallocated via -dealloc call! -release doesn't work!
 */
@interface UndirectednessAdapter : NSProxy <UndirectedGraph>
{
  @private
    // Используем базовый класс NSObject, т.к. нам требуется его метод -methodSignatureForSelector:.
    NSObject<DirectedGraph>* directedGraph;
}

@property(readwrite, retain) NSObject<DirectedGraph>* directedGraph;

+ (UndirectednessAdapter*) adapterWithDirectedGraph: (NSObject<DirectedGraph>*) graph;

- (id) initWithDirectedGraph: (NSObject<DirectedGraph>*) graph;

@end
